'To Do:
'
'1. Change bitrate selection to seeing the wave bitrate and just seeing what
'   it's closest to, don't just support specific bitrates.

DIM i AS LONG, h AS INTEGER
DIM EqualCount AS INTEGER

IF COMMAND$ = "" THEN
   PRINT "Usage: WAV2NES filename[.wav]"
   PRINT
   PRINT "Ex: `WAV2NES tada' or `WAV2NES tada.wav' to convert tada.wav"
   SYSTEM
END IF

IF UCASE$(RIGHT$(COMMAND$, 4)) = ".WAV" THEN
   filenamebase$ = LEFT$(COMMAND$, LEN(COMMAND$) - 4)
ELSE
   filenamebase$ = COMMAND$
END IF

CLS
PRINT "Converting WAV file to DMC format..."

OPEN filenamebase$ + ".wav" FOR BINARY AS #1
ON ERROR RESUME NEXT
KILL filenamebase$ + ".snd"
ON ERROR GOTO 0

IF LOF(1) > 8257536 THEN errormsg$ = "WAV File longer than supported limit (8mb minus 128k)...": GOTO errorout

OPEN filenamebase$ + ".snd" FOR BINARY AS #2

DIM a2 AS STRING * 8, z2 AS STRING * 1, ztmp2 AS INTEGER

DIM filledblocks AS STRING * 1, lolastblock AS STRING * 1
DIM playbackrate AS STRING * 1

filledblocks = CHR$(((LOF(1) - (&H3A + 1)) \ 128) \ 256)
lolastblock = CHR$(((LOF(1) - (&H3A + 1)) \ 128) AND 255)

GET #1, &H17, z2
IF ASC(z2) = 2 THEN errormsg$ = "Wave is in Stereo Format...  Not supported yet...": GOTO errorout

GET #1, &H2F, z2
IF ASC(z2) = 1 THEN errormsg$ = "Wave is in 16-Bit...  Not supported yet...": GOTO errorout

GET #1, &H19, ztmp2
DIM ztmp22 AS LONG
ztmp22 = ztmp2
IF ztmp22 < 0 THEN ztmp22 = ztmp22 + 32768
SELECT CASE ztmp22
   CASE 8000: playbackrate = CHR$(6)  '8k
   CASE 11025: playbackrate = CHR$(9)  '11k
   CASE 12000: playbackrate = CHR$(10)  '12k
   CASE 16000: playbackrate = CHR$(12)  '16k
   CASE 22050: playbackrate = CHR$(13)  '22k
   CASE 24000: playbackrate = CHR$(14)  '24k
   CASE 32000: playbackrate = CHR$(15) '32k
   CASE 37800: playbackrate = CHR$(15): warnmsg$ = "Wave is at 38k, and the NES only goes to 32k so it will sound slow..." '38k
   CASE 44100: playbackrate = CHR$(15): warnmsg$ = "Wave is at 44k, and the NES only goes to 32k so it will sound slow..." '44k
   CASE 48000: playbackrate = CHR$(15): warnmsg$ = "Wave is at 48k, and the NES only goes to 32k so it will sound slow..." '48k
   CASE ELSE: errormsg$ = STR$(ztmp2) + ": Bitrate not supported...": GOTO errorout
END SELECT

DIM tmpstrit AS STRING
tmpstrit = SPACE$(16385)

DIM aaaaa AS INTEGER

DIM ls AS INTEGER, rs AS INTEGER

FOR i = 0 TO ((LOF(1) - &H3A) \ 16384) - 1
   IF i = ((LOF(1) - &H3A) \ 16384) - 1 THEN
      aaaaa = (LOF(1) - &H3A) MOD 16384
      tmpstrit = SPACE$(aaaaa + 1)
      GET #1, &H3B + (i * 16384) - 1, tmpstrit
      IF (aaaaa AND 7) > 0 THEN
         tmpstrit = tmpstrit + STRING$(8 - (aaaaa AND 7), &H55)
      END IF
   ELSE
      GET #1, &H3B + (i * 16384) - 1, tmpstrit
   END IF

   FOR h = 2 TO LEN(tmpstrit) STEP 8

      ls = ASC(MID$(tmpstrit, h + 0, 1)): rs = ASC(MID$(tmpstrit, h - 1, 1))
      IF ls > rs + 1 THEN
         ztmp2 = 1
      ELSEIF ls < rs - 1 THEN
         ztmp2 = 0
      ELSE
         ztmp2 = EqualCount
         EqualCount = EqualCount XOR 1
      END IF

      ls = ASC(MID$(tmpstrit, h + 1, 1)): rs = ASC(MID$(tmpstrit, h + 0, 1))
      IF ls > rs + 1 THEN
         ztmp2 = ztmp2 OR 2
      ELSEIF ls < rs - 1 THEN
      ELSE
         IF EqualCount = 1 THEN ztmp2 = ztmp2 OR 2
         EqualCount = EqualCount XOR 1
      END IF

      ls = ASC(MID$(tmpstrit, h + 2, 1)): rs = ASC(MID$(tmpstrit, h + 1, 1))
      IF ls > rs + 1 THEN
         ztmp2 = ztmp2 OR 4
      ELSEIF ls < rs - 1 THEN
      ELSE
         IF EqualCount = 1 THEN ztmp2 = ztmp2 OR 4
         EqualCount = EqualCount XOR 1
      END IF

      ls = ASC(MID$(tmpstrit, h + 3, 1)): rs = ASC(MID$(tmpstrit, h + 2, 1))
      IF ls > rs + 1 THEN
         ztmp2 = ztmp2 OR 8
      ELSEIF ls < rs - 1 THEN
      ELSE
         IF EqualCount = 1 THEN ztmp2 = ztmp2 OR 8
         EqualCount = EqualCount XOR 1
      END IF

      ls = ASC(MID$(tmpstrit, h + 4, 1)): rs = ASC(MID$(tmpstrit, h + 3, 1))
      IF ls > rs + 1 THEN
         ztmp2 = ztmp2 OR 16
      ELSEIF ls < rs - 1 THEN
      ELSE
         IF EqualCount = 1 THEN ztmp2 = ztmp2 OR 16
         EqualCount = EqualCount XOR 1
      END IF

      ls = ASC(MID$(tmpstrit, h + 5, 1)): rs = ASC(MID$(tmpstrit, h + 4, 1))
      IF ls > rs + 1 THEN
         ztmp2 = ztmp2 OR 32
      ELSEIF ls < rs - 1 THEN
      ELSE
         IF EqualCount = 1 THEN ztmp2 = ztmp2 OR 32
         EqualCount = EqualCount XOR 1
      END IF

      ls = ASC(MID$(tmpstrit, h + 6, 1)): rs = ASC(MID$(tmpstrit, h + 5, 1))
      IF ls > rs + 1 THEN
         ztmp2 = ztmp2 OR 64
      ELSEIF ls < rs - 1 THEN
      ELSE
         IF EqualCount = 1 THEN ztmp2 = ztmp2 OR 64
         EqualCount = EqualCount XOR 1
      END IF

      ls = ASC(MID$(tmpstrit, h + 7, 1)): rs = ASC(MID$(tmpstrit, h + 6, 1))
      IF ls > rs + 1 THEN
         ztmp2 = ztmp2 OR 128
      ELSEIF ls < rs - 1 THEN
      ELSE
         IF EqualCount = 1 THEN ztmp2 = ztmp2 OR 128
         EqualCount = EqualCount XOR 1
      END IF

      z2 = CHR$(ztmp2)
      PUT #2, , z2
   NEXT h
   LOCATE 1, 40: PRINT "%"; INT(100 * i / ((LOF(1) - &H3A) \ 16384))
NEXT i
LOCATE 1, 40: PRINT "100%"

errorout:

CLOSE #1
CLOSE #2

IF LEN(errormsg$) > 0 THEN
   PRINT "A fatal error has occured:"
   PRINT , errormsg$
   ON ERROR RESUME NEXT
   KILL filenamebase$ + ".snd"
   ON ERROR GOTO 0
   SYSTEM
END IF

IF LEN(warnmsg$) > 0 THEN
   PRINT "A warning occurred:"
   PRINT , warnmsg$
   FOR asdf = 0 TO 20000
      FOR asdf2 = 0 TO 100
      NEXT asdf2
   NEXT asdf
END IF


PRINT "Compiling to NES file..."

OPEN "wav2nes.dat" FOR BINARY AS #1
ON ERROR RESUME NEXT
KILL filenamebase$ + ".nes"
ON ERROR GOTO 0
OPEN filenamebase$ + ".nes" FOR BINARY AS #2
OPEN filenamebase$ + ".snd" FOR BINARY AS #4

PRGPages = 2

DIM esndbanks AS INTEGER
lof4 = LOF(4)

IF (lof4 MOD &H2000) > 0 THEN lof4 = lof4 - (lof4 MOD &H2000) + &H2000

esndbanks = (lof4 \ &H2000) - 2
IF esndbanks > 0 THEN
   IF (esndbanks AND 3) > 0 THEN esndbanks = esndbanks + (4 - (esndbanks AND 3))
   FOR i = 2 TO 8
      IF (2 + esndbanks \ 2) < (2 ^ i) THEN esndbanks = 2 * ((2 ^ i) - 2)
      IF (2 + esndbanks \ 2) = (2 ^ i) THEN EXIT FOR
   NEXT i
   PRGPages = 2 + esndbanks \ 2
END IF

lof1 = LOF(1)

DIM header AS STRING * 16

header = "NES" + CHR$(&H1A) + CHR$(PRGPages) + CHR$(CHRPages) + CHR$(&H10) + CHR$(&H10) + STRING$(8, CHR$(0))

PUT #2, 1, header

DIM a AS STRING * 1

LOCATE 2, 40: PRINT "[X....]"

'zero out whole
DIM tmpstrn AS STRING
tmpstrn = STRING$(32767, 0)
a = CHR$(0)

FOR h = 0 TO (PRGPages \ 2) - 1
   PUT #2, 17 + h * 32768, tmpstrn
   PUT #2, 18 + h * 32768, a
NEXT h

LOCATE 2, 40: PRINT "[XX...]"

'write wav player code
FOR i = 0 TO lof1 - 6 - 1
   GET #1, i + 1, a
   PUT #2, i + 16 + 1, a
NEXT i

LOCATE 2, 40: PRINT "[XXX..]"

PUT #2, 16 + 1 + &H1000, filledblocks
PUT #2, 16 + 1 + &H1001, lolastblock
PUT #2, 16 + 1 + &H1002, playbackrate

LOCATE 2, 40: PRINT "[XXXx.]"

'fill in vectors at end
FOR i = 0 TO 5
   GET #1, lof1 - 5 + i, a
   PUT #2, 16 + PRGPages * 16384& + 1 - 6 + i, a
NEXT i

LOCATE 2, 40: PRINT "[XXXX.]"

'fill in snd code
DIM tmpstrit2 AS STRING
tmpstrit = SPACE$(16384)
tmpstrit2 = SPACE$(LOF(4) MOD 16384)

FOR i = 0 TO (LOF(4) \ 16384) - 1
   GET #4, 1 + i * 16384, tmpstrit
   PUT #2, 8209 + i * 16384, tmpstrit
NEXT i

GET #4, 1 + (LOF(4) \ 16384) * 16384, tmpstrit2
PUT #2, 8209 + (LOF(4) \ 16384) * 16384, tmpstrit2


LOCATE 2, 40: PRINT "[XXXXX]"

CLOSE #1
CLOSE #2
CLOSE #4
ON ERROR RESUME NEXT
'KILL filenamebase$ + ".snd"
ON ERROR GOTO 0

PRINT "Done!"
PRINT

